/* $VER: CfgSOUP.thor 1.0 (12.12.94)
 *
 * External configuration for the SOUP bbstype.
 *
 *  Script by: Kjell Irgens & Magne stlyngen, Ultima Thule Software.
 */

parse arg argument
options results

template = 'BBSNAME,CONFNAME/K,PUBSCREEN/K'

p=address()||' '||show('P',,);if pos('THOR.',p)>0 then thorport=word(,
substr(p,pos('THOR.',p)),1);else do;say 'No THOR port found!';exit 10;end

if ~show('p', 'BBSREAD') then do
	address command
		"run >nil: `GetEnv THOR/THORPath`bin/LoadBBSRead"
		"WaitForPort BBSREAD"
end

address "BBSREAD"

READARGS template ARGS CMDLINE argument
if rc ~= 0 then exit

GETBBSDATA bbsname '"'ARGS.BBSNAME'"' stem BBSDATA
if rc ~= 0 then do
	address(thorport)
	REQUESTNOTIFY TEXT '"'BBSREAD.LASTERROR'"' BT '"_Ok"'
	exit 5
end

address(thorport)

REQUESTNOTIFY TEXT '"Edit or delete all header fields?"' BT '"_Edit|_Delete|_Cancel"'

if result = 1 then do
	if ~exists(BBSDATA.BBSPATH||".header") then
		REQUESTNOTIFY TEXT '"You may now edit extra header lines to appear\nin the editor when you write messages.\nFollowup-To: and Keywords: are good examples."' BT '"_Ok"'
	STARTEDITOR FILE BBSDATA.BBSPATH||".header"
end
if result = 2 then address command "delete >NIL: "||BBSDATA.BBSPATH||".header"
